题目描述
在数组中的两个数字,如果前面一个数字大于后面的数字,则这两个数字组成一个逆序对。输入一个数组,求出这个数组中的逆序对的总数P。并将P对1000000007取模的结果输出。 即输出P%1000000007
输入描述:
题目保证输入的数组中没有的相同的数字
数据范围:
对于%50的数据,size<=10^4
对于%75的数据,size<=10^5
对于%100的数据,size<=2*10^5
解法1:递归
归并排序的衍生,在归并过程中统计逆序对
class Solution {
public:
int InversePairs(vector<int> data)
{
int length=data.size();
if(length<=0)
return 0;
//vector<int> copy=new vector<int>[length];
vector<int> copy;
for(int i=0;i<length;i++)
copy.push_back(data[i]);
long long count=InversePairsCore(data,copy,0,length-1);//调用子函数
//delete[]copy;
return count%1000000007;
}
long long InversePairsCore(vector<int> &data,vector<int> ©,int start,int end)
{
if(start==end)//递归结束条件
{
copy[start]=data[start];
return 0;
}
int length=(end-start)/2;
long long left=InversePairsCore(copy,data,start,start+length);//递归调用左半边
long long right=InversePairsCore(copy,data,start+length+1,end); //递归调用右半边
//i 初始化为前半段最后一个数字的下标
int i=start+length;
// j 初始化为后半段最后一个数字的下标
int j=end;
int indexcopy=end;
long long count=0;
while(i>=start&&j>=start+length+1)
{
if(data[i]>data[j])
{
copy[indexcopy--]=data[i--];
count=count+j-start-length; //count=count+j-(start+length+1)+1;
}
else
{
copy[indexcopy--]=data[j--];
}
}
for(;i>=start;i--)
copy[indexcopy--]=data[i];
for(;j>=start+length+1;j--)
copy[indexcopy--]=data[j];
return left+right+count;//left和right 保留了递归返回阶段的每次count值并求和
}
};
//注意最后一步排序好,由于是升序,为此都不构成逆序对,不参与统计逆序对
(a) 把长度为4的数组分解成两个长度为2的子数组;
(b) 把长度为2的数组分解成两个成都为1的子数组;
(c) 把长度为1的子数组 合并、排序并统计逆序对 ;
(d) 把长度为2的子数组合并、排序,并统计逆序对
注意:辅助数组由于是升序排列,不统计逆序对,从而避免了重复统计
参考: 【1】https://www.nowcoder.com/profile/4620097/codeBookDetail?submissionId=35997120
【2】文章:5.输入两个单调递增的链表,输出两个链表合成后的链表,当然我们需要合成后的链表满足单调不减规则https://blog.youkuaiyun.com/heda3/article/details/86566598 使用的合并函数类似
【3】归并排序 https://blog.youkuaiyun.com/heda3/article/details/86756026